// Flag para determinar si el navegador es IE
var isIE = false;
// Para el request de documentos XML
var req;
// Obtiene un documento XML a partir del URL pasado
// como parámetro, tiene referenciara un documento 
// XML válido
function CargarDocumentoXML(url) {
    // Determina si existe el objeto XMLHttpRequest
    if (window.XMLHttpRequest) {
		// Crea el nuevo objeto
        req = new XMLHttpRequest();
		// Cuando el documento está listo, invoca a la función Procesar
        req.onreadystatechange = procesar;
		// Asigna el método, el URL y demás parámetros
        req.open("GET", url, true);
		// Envía el pedido
        req.send(null);
    // La versión en ActiveX para IE/Windows
    } else if (window.ActiveXObject) {
        isIE = true;
		// Crea el nuevo objeto
        req = new ActiveXObject("Microsoft.XMLHTTP");
        if (req) {
			// Cuando el documento está listo, invoca a la función Procesar
            req.onreadystatechange = procesar;
			// Asigna el método, el URL y demás parámetros
			req.open("GET", url, true);
			// Envía el pedido
            req.send();
        }
    }
}
// Maneja el evento onreadystatechange del objeto req
function procesar() {
    // Solo si el documento ya está cargado
	// Otros estados son:
	// 0 = uninitialized <-> 1 = loading <-> 2 = loaded <-> 3 = interactive <-> 4 = complete
    if (req.readyState == 4) {
        // Sólo si hay respuesta positiva "OK", esto es enviado por el servidor
        if (req.status == 200) {
            limpiarProductos();
            cargarProductos();
         } else {
            alert("Hubo un problema al intentar obtener el documento XML:\n" + req.statusText);
         }
    }
}
// Carga los productos de acuerdo a la categoría seleccionada
function CargarDocumento(url, evt) {
    evt = (evt) ? evt : ((window.event) ? window.event : null);
    if (evt) {
        var elem = (evt.target) ? evt.target : ((evt.srcElement) ? evt.srcElement : null);
        if (elem) {
            try {
                if (elem.selectedIndex > 0) {
                    CargarDocumentoXML(url+elem.options[elem.selectedIndex].value);
                }	
            }
            catch(e) {
                var msg = (typeof e == "string") ? e : ((e.message) ? e.message : "Error Desconocido");
                alert("No se puede acceder al documento XML:\n" + msg);
                return;
            }
        }
    }
}
// Obtiene el texto de un elemento de un documento XML
// incluyendo elementos usando espacios de nombre (namespaces)
function getElementTextNS(prefix, local, parentElem, index) {
    var result = "";
    if (prefix && isIE) {
        // IE/Windows way of handling namespaces
        result = parentElem.getElementsByTagName(prefix + ":" + local)[index];
    } else {
        // the namespace versions of this method 
        // (getElementsByTagNameNS()) operate
        // differently in Safari and Mozilla, but both
        // return value with just local name, provided 
        // there aren't conflicts with non-namespace element
        // names
        result = parentElem.getElementsByTagName(local)[index];
    }
    if (result) {
        // get text, accounting for possible
        // whitespace (carriage return) text nodes 
        if (result.childNodes.length > 1) {
            return result.childNodes[1].nodeValue;
        } else {
            return result.firstChild.nodeValue;    		
        }
    } else {
        return "n/a";
    }
}

/*******************************************************/
// Esto es específico para cada aplicación

// Vacía los productos que están en el combo
function limpiarProductos() {
    var select = document.getElementById("productos");
    while (select.length > 1) {
        select.remove(1);
    }
}
// Añadir un nuevo producto a la lista de productos
function AgregarProducto(select, value, content) {
    var opt;
    opt = document.createElement("option");
    opt.value = value;
    opt.appendChild(content);
    select.appendChild(opt);
}
// Carga la lista de productos
function cargarProductos() {
    var select = document.getElementById("productos");
    var items = req.responseXML.getElementsByTagName("producto");
	
    for (var i = 0; i < items.length; i++) {
			idprod=getElementTextNS("", "idprod", items[i], 0);
			nombre=getElementTextNS("", "nombre", items[i], 0);
			AgregarProducto(select, idprod, document.createTextNode(nombre));
    }
}